//Title:        GulchDiscussPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Component for GulchDiscuss

package gulch2000;

import javax.swing.*;
import javax.swing.tree.*;


import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.borland.jbcl.layout.*;
import pow2000.TreeDataRow;
import pow2000.InterfaceMessageDef;

public class GulchDiscussPane extends JPanel {
    public GulchDiscuss parentPanel = null;
    GulchTreePane treePane;
    GulchTabbedPane tabbedPane;
    DefaultMutableTreeNode node;
    DefaultMutableTreeNode secondNode;
    private String perspectiveName = "";
    private int maxDepth = 0;
    private int currentDepth = 0;
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JTextArea messageTextArea = new JTextArea();
    JRadioButton titleRadioButton = new JRadioButton();
    JRadioButton contentRadioButton = new JRadioButton();
    ButtonGroup group = new ButtonGroup();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    JButton jButton4 = new JButton();
    JButton jButton5 = new JButton();
    JButton jButton6 = new JButton();
    JButton jButton7 = new JButton();
    JButton jButton8 = new JButton();
    JButton jButton9 = new JButton();
    JButton jButton10 = new JButton();
    JButton jButton11 = new JButton();
    JButton jButton12 = new JButton();
    JButton jButton13 = new JButton();
    JButton jButton14 = new JButton();
    BorderLayout borderLayout1 = new BorderLayout();
    XYLayout xYLayout1 = new XYLayout();
    JTextField authorTextField = new JTextField();
    JLabel jLabel1 = new JLabel();
    String blankLine = "                                                                  ";
    String blankMessage = blankLine + blankLine + blankLine + blankLine + blankLine + blankLine + blankLine;
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();

    /**
    Construct the component as a JavaBean
    */
    public GulchDiscussPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchDiscussPane(GulchDiscuss pane) {
        parentPanel = pane;
        treePane = (GulchTreePane) parentPanel.leftPane;
        tabbedPane = (GulchTabbedPane) parentPanel.parent;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        //this.setPreferredSize(new Dimension(300, 345));
        this.setLayout(borderLayout1);
        this.setBackground(SystemColor.controlShadow);
        this.setMinimumSize(new Dimension(250, 300));
        jPanel1.setBackground(SystemColor.control);
        jPanel1.setMaximumSize(new Dimension(100, 307));
        jPanel1.setMinimumSize(new Dimension(100, 307));
        jPanel1.setPreferredSize(new Dimension(100, 307));
        jPanel1.setLayout(verticalFlowLayout1);
        jPanel2.setBackground(SystemColor.control);
        jPanel2.setLayout(xYLayout1);
        titleRadioButton.setText("show title");
        titleRadioButton.setSelected(true);
        contentRadioButton.setText("show content");
        messageTextArea.setLineWrap(true);
        messageTextArea.setRows(4);
        messageTextArea.setText("messages:");
        messageTextArea.setForeground(new Color(0, 0, 170));
        messageTextArea.setPreferredSize(new Dimension(205, 75));
        messageTextArea.setFont(new Font("Dialog", 1, 12));
        messageTextArea.setEditable(false);
        jButton1.setText("discuss");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton1_actionPerformed(e);
            }
        });
        jButton2.setText("new note");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton2_actionPerformed(e);
            }
        });
        jButton3.setText("edit note");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton3_actionPerformed(e);
            }
        });
        jButton4.setText("delete note");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton4_actionPerformed(e);
            }
        });
        jButton5.setText("move note");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton5_actionPerformed(e);
            }
        });
        jButton6.setText("copy note");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton6_actionPerformed(e);
            }
        });
        jButton7.setText("link note");
        jButton7.setMargin(new Insets(2, 2, 2, 2));
        jButton7.setRolloverEnabled(true);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton7_actionPerformed(e);
            }
        });
        jButton8.setText("copy  to home");
        jButton8.setMargin(new Insets(2, 2, 2, 2));
        jButton8.setRolloverEnabled(true);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton8_actionPerformed(e);
            }
        });
        jButton9.setText("link  to home");
        jButton9.setMargin(new Insets(2, 2, 2, 2));
        jButton9.setRolloverEnabled(true);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton9_actionPerformed(e);
            }
        });
        jButton10.setText("email from note");
        jButton10.setMargin(new Insets(2, 2, 2, 2));
        jButton10.setRolloverEnabled(true);
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton10_actionPerformed(e);
            }
        });
        jButton11.setText("select second note");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton11_actionPerformed(e);
            }
        });
        jButton12.setText("private note");
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton12_actionPerformed(e);
            }
        });
        jButton13.setText("proposal");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton13_actionPerformed(e);
            }
        });
        jButton14.setText("vote");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton14_actionPerformed(e);
            }
        });
        jLabel1.setText("author:");
        jPanel3.setPreferredSize(new Dimension(50, 50));
        jPanel4.setPreferredSize(new Dimension(50, 50));
        authorTextField.setText("current author");
        authorTextField.setForeground(new Color(0, 0, 162));
        authorTextField.setFont(new Font("SansSerif", 1, 12));
        authorTextField.setEditable(false);
        group.add(titleRadioButton);
        group.add(contentRadioButton);
        this.add(messageTextArea, BorderLayout.SOUTH);
        this.add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jButton1, null);
        jPanel1.add(jButton2, null);
        jPanel1.add(jButton3, null);
        jPanel1.add(jButton4, null);
        jPanel1.add(jButton5, null);
        jPanel1.add(jButton6, null);
        jPanel1.add(jButton7, null);
        jPanel1.add(jButton8, null);
        jPanel1.add(jButton9, null);
        jPanel1.add(jButton10, null);
        jPanel1.add(jButton11, null);
        jPanel1.add(jButton12, null);
        jPanel1.add(jButton13, null);
        jPanel1.add(jButton14, null);
        this.add(jPanel4, BorderLayout.WEST);
        this.add(jPanel2, BorderLayout.NORTH);
        jPanel2.add(titleRadioButton, new XYConstraints(10, 27, 136, -1));
        jPanel2.add(authorTextField, new XYConstraints(50, 5, 241, 18));
        jPanel2.add(jLabel1, new XYConstraints(5, 5, 57, 18));
        jPanel2.add(contentRadioButton, new XYConstraints(151, 30, -1, -1));
        this.add(jPanel3, BorderLayout.EAST);
    }

    /**
    Check permissions to use buttons.
    If in author's home perspective, enable everything except link-to-home and copy-to-home.
    Except if author is guest, then also disable edit and delete.
    If not in author's home only enable copy-to-home and link-to-home.
    Option to select second note must be enabled when needed
    */
    void checkPermissions() {
        //default: disable all buttons except private
        jButton1.setEnabled(false);         // discuss
        jButton2.setEnabled(false);         // new note
        jButton3.setEnabled(false);         // edit
        jButton4.setEnabled(false);         // delete
        jButton5.setEnabled(false);         // move
        jButton6.setEnabled(false);         // copy
        jButton7.setEnabled(false);         // link
        jButton8.setEnabled(false);         // copy home
        jButton9.setEnabled(false);         // link home
        jButton10.setEnabled(false);        // email
        jButton11.setEnabled(false);        // second
        jButton12.setEnabled(true);         // private
        jButton13.setEnabled(false);        // propose
        jButton14.setEnabled(false);        // vote
        if (tabbedPane.getAuthorName().equalsIgnoreCase("Admin") ) {
            //Admin has permission to do everything everywhere anytime
            jButton1.setEnabled(true);
            jButton2.setEnabled(true);
            jButton3.setEnabled(true);
            jButton4.setEnabled(true);
            jButton5.setEnabled(true);
            jButton6.setEnabled(true);
            jButton7.setEnabled(true);
            jButton8.setEnabled(true);
            jButton9.setEnabled(true);
            jButton10.setEnabled(true);
            jButton11.setEnabled(false);
            jButton12.setEnabled(true);
            jButton13.setEnabled(true);
            jButton14.setEnabled(true);
        }
        else {      //enable depending on current display mode
            if (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_GROUP) {
                //just leave Private Note enabled unless "Group" is logged in
                if (tabbedPane.getAuthorName().equalsIgnoreCase("Group") ) {
                    //Group has permission to do everything in Group perspective
                    jButton1.setEnabled(true);
                    jButton2.setEnabled(true);
                    jButton3.setEnabled(true);
                    jButton4.setEnabled(true);
                    jButton5.setEnabled(true);
                    jButton6.setEnabled(true);
                    jButton7.setEnabled(true);
                    jButton8.setEnabled(true);
                    jButton9.setEnabled(true);
                    jButton10.setEnabled(true);
                    jButton11.setEnabled(false);
                    jButton12.setEnabled(true);
                    jButton13.setEnabled(true);
                    jButton14.setEnabled(true);
                }
            }
            else {
                if ( (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_DISCUSSION) ||
                     (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_OTHER) ||
                     (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_COMPARISON) ||
                     (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_ARCHIVE) ) {
                        jButton1.setEnabled(true);
                        jButton8.setEnabled(true);
                        jButton9.setEnabled(true);
                }
                else {
                    if (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_NEGOTIATION) {
                        if (!(tabbedPane.getAuthorName().equalsIgnoreCase("guest") ) ) {
                            jButton13.setEnabled(true);      // Guest cannot propose or vote
                            jButton14.setEnabled(true);
                        }
                        jButton1.setEnabled(true);
                        jButton8.setEnabled(true);
                        jButton9.setEnabled(true);
                    }
                    else {
                        if (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_PERSONAL) {
                            jButton1.setEnabled(true);
                            jButton2.setEnabled(true);
                            jButton3.setEnabled(true);
                            jButton4.setEnabled(true);
                            jButton5.setEnabled(true);
                            jButton6.setEnabled(true);
                            jButton7.setEnabled(true);
                         // jButton10.setEnabled(true);     // email
                        }   // Personal
                    }       // Negotiation
                }           // Misc
            }               // Group
        }                   // Admin
    }

    /**
    disable all buttons except SecondButton
    */
    void displaySecondButton() {
        jButton1.setEnabled(false);
        jButton2.setEnabled(false);
        jButton3.setEnabled(false);
        jButton4.setEnabled(false);
        jButton5.setEnabled(false);
        jButton6.setEnabled(false);
        jButton7.setEnabled(false);
        jButton8.setEnabled(false);
        jButton9.setEnabled(false);
        jButton10.setEnabled(false);
        jButton12.setEnabled(false);
        jButton13.setEnabled(false);
        jButton14.setEnabled(false);
        jButton11.setEnabled(true);
    }

    /**
    addDiscussionButton. add discussion of selected note
    */
    void jButton1_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankLine);
                messageTextArea.setText("Message: You must select a note to discuss first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("addDiscussionButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to discuss first.");
            return;
        }
    }

    /**
    addNewNoteButton. add new note to selected note
    */
    void jButton2_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to link to first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("addNewNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to link to first.");
            return;
        }
    }

    /**
    editNoteButton. edit selected note
    */
    void jButton3_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to edit first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("editNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setKind(row.getKind());
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to edit first.");
            return;
        }
    }

    /**
    deleteNoteButton. delete selected note
    */
    void jButton4_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to delete first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("deleteNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to delete first.");
            return;
        }
    }

    /**
    moveNoteButton. move selected note after/below second note within same perspective
    */
    void jButton5_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            DefaultMutableTreeNode parentNode = (DefaultMutableTreeNode) node.getParent();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to move first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                TreeDataRow parentRow = (TreeDataRow) parentNode.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("moveNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setParentNid(parentRow.getNid());    
                tabbedPane.setNid(row.getNid());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to move this one after or below.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to move first.");
            return;
        }
    }

    /**
    copyNoteButton. copy selected note after/below second note within same perspective
    */
    void jButton6_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to copy first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("copyNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to copy this one after or below.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to copy first.");
            return;
        }
    }

    /**
    linkNoteButton. link selected note to a new parent note within same perspective
    */
    void jButton7_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to be linked first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("linkNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to link to as this one's parent.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to be linked first.");
            return;
        }
    }

    /**
    copyToHomeButton. copy selected note after/below second note in home perspective
    */
    void jButton8_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to copy first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("copyToHomeButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to copy this one after or below.  " +
                                        "The second note must be in your home personal perspective. " +
                                        "Then press the button to Select Note as Second Item.");
                //switch to home perspective in perspectiveComboBox and refresh tree
                tabbedPane.setCurrentPerspective(tabbedPane.getHomePerspective());
                treePane.refreshPerspectiveComboBox();
                treePane.refreshTree();
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to copy first.");
            return;
        }
    }

    /**
    linkToHomeButton. link selected note after/below second note in home perspective
    */
    void jButton9_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to be linked first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("linkToHomeButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to link to as this one's parent.  " +
                                        "The second note must be in your home personal perspective. " +
                                        "Then press the button to Select Note as Second Item.");
                //switch to home perspective in perspectiveComboBox and refresh tree
                tabbedPane.setCurrentPerspective(tabbedPane.getHomePerspective());
                treePane.refreshPerspectiveComboBox();
                treePane.refreshTree();
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to be linked first.");
            return;
        }
    }

    /**
    emailButton. send email from selected note
    */
    void jButton10_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to email about first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //call cgi script and pass it variables pointing to the selected note, perspectiveNid, author and database
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("emailNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: The email function is not yet operational." );
        //        messageTextArea.setText("Message: Fill out the email form below and send it.  " +
        //                                "Your message and any email responses to it will appear below the note you selected.");
                //done -- user can do something else
                checkPermissions();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to email about first.");
            return;
        }
    }

    /**
    selectSecondButton. select note as second item for editing
    */
    void jButton11_actionPerformed(ActionEvent e) {
        try {
            // process rest of move, copy, virtual copy or link
            if ((tabbedPane.getButton().equals("moveNoteButton")) |
                    (tabbedPane.getButton().equals("copyNoteButton")) |
                    (tabbedPane.getButton().equals("linkNoteButton")) |
                    (tabbedPane.getButton().equals("copyToHomeButton")) |
                    (tabbedPane.getButton().equals("linkToHomeButton"))  ) {
                //store second selected note and perspective
                secondNode = treePane.getSelectedNode();
                TreeDataRow secondRow = (TreeDataRow) secondNode.getUserObject();
                int firstNid = tabbedPane.getNid();
                //if (secondNode == null | firstNid == secondRow.getNid()) {     //would not allow copy under same note in dif p
                if (secondNode == null) {
                    messageTextArea.setText(blankMessage);
                    messageTextArea.setText("Message: You must select a note to serve as second item.");
                }
                else {
                    //save secondNode in parent variables
                    DefaultMutableTreeNode secondParentNode = (DefaultMutableTreeNode) secondNode.getParent();
                    TreeDataRow secondParentRow = (TreeDataRow) secondParentNode.getUserObject();
                    tabbedPane.setSecondParentNid(secondParentRow.getNid());
                    tabbedPane.setSecondNode(secondNode);
                    tabbedPane.setSecondNid(secondRow.getNid());
                    tabbedPane.setSecondSelection(secondRow.getDescription());
                    tabbedPane.setSecondPerspectiveNid(tabbedPane.getCurrentPerspective());
                    tabbedPane.setSecondPerspectiveName(tabbedPane.getCurrentPerspectiveName());
                    //switch to Editing component, which will return here
                    treePane.perspectiveComboBox.setEnabled(true);
                    checkPermissions();
                    tabbedPane.addEdit();
                }
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to serve as second item.");
            return;
        }
    }

    /**
    addPrivateButton. add private annotation of selected note
    */
    void jButton12_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankLine);
                messageTextArea.setText("Message: You must select a note to discuss first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("addPrivateButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to discuss first.");
            return;
        }
    }

    /**
    addProposalButton. add discussion of selected note
    */
    void jButton13_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankLine);
                messageTextArea.setText("Message: You must select a note to discuss first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();    //row = selected note
                if ((row.getName() != "Proposals") || (row.getKindName() != "heading")) {
                    messageTextArea.setText(blankLine);
                    messageTextArea.setText("Message: You must select the PROPOSALS note to add a new proposal.");
                }
                else {
                    //save component, button, node and nid of selected note in parent variables
                    tabbedPane.setComponent(tabbedPane.discuss1);
                    tabbedPane.setButton("addProposalButton");
                    tabbedPane.setNode(node);
                    tabbedPane.setNid(row.getNid());
                    tabbedPane.setFirstSelection(row.getDescription());
                    tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                    tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                    //switch to Editing component, which will return here
                    tabbedPane.addEdit();
                }
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to discuss first.");
            return;
        }
    }

    /**
    addDecisionButton. add discussion of selected note
    */
    void jButton14_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankLine);
                messageTextArea.setText("Message: You must select a note to discuss first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                if (row.getKind() != tabbedPane.state1.getPROPOSAL()) {
                    messageTextArea.setText(blankLine);
                    messageTextArea.setText("Message: You must add a Decision below a Proposal note.");
                }
                else {
                    //save component, button, node and nid of selected note in parent variables
                    tabbedPane.setComponent(tabbedPane.discuss1);
                    tabbedPane.setButton("addDecisionButton");
                    tabbedPane.setNode(node);
                    tabbedPane.setNid(row.getNid());
                    tabbedPane.setFirstSelection(row.getDescription());
                    tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                    tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                    //switch to Editing component, which will return here
                    tabbedPane.addEdit();
                }
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to discuss first.");
            return;
        }
    }

    public void setAuthorTextField(String msg) {
        authorTextField.setText(msg);
    }

    public void setMessageTextArea(String msg) {
        messageTextArea.setText(msg);
    }
}






































