
//Title:        GulchLogin.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Login component

package gulch2000;

public class GulchLogin extends GulchPane {

    /**
    Construct the component as a JavaBean
    */
    public GulchLogin() {
        super();
        System.out.println("WARNING: component called without pointer to parent");
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchLogin(GulchTabbedPane pane) {
        super(pane);
    }

    /**
    override dummy splitPaneSetup()
    Set up leftPane as GulchWelcomePane and rightPane as GulchLoginPane
    */
    void splitPaneSetup() {
        leftPane = new GulchWelcomePane(this);
        rightPane = new GulchLoginPane(this);
    }

    /**
    override dummy refreshContent()
    Initialize GulchContentPane and GulchEditingPane
    */
    void refreshContent() {
        //initialize GulchLoginPane with list of spaces
        GulchLoginPane contentPane = (GulchLoginPane) rightPane;
        contentPane.refreshSpacesComboBox();
    }

}

