
//Title:        GulchLoginPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Pane for Login component

package gulch2000;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.sql.*;
import java.io.IOException;
import java.util.*;
import java.net.URL;
import com.borland.jbcl.layout.VerticalFlowLayout;
import pow2000.InterfaceMessageDef;

public class GulchLoginPane extends JPanel {
    public GulchLogin parentPanel;
    GulchTabbedPane tabbedPane;
    private int DBsid = 0;;
    private String username;
    private String password;
    private JLabel usernameLabel = new JLabel();
    private JLabel passwordLabel = new JLabel();
    private JTextField usernameTextField = new JTextField();
    private JPasswordField passwordTextField = new JPasswordField();
    private JButton loginButton = new JButton();
    private JButton logoutButton = new JButton();
    JTextArea messageTextArea = new JTextArea();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel1 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    JPanel jPanel2 = new JPanel();
    GridLayout gridLayout3 = new GridLayout();
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
    JComboBox spacesComboBox = new JComboBox();
    JPanel jPanel3 = new JPanel();
    JPasswordField jPasswordField1 = new JPasswordField();
    JPasswordField jPasswordField2 = new JPasswordField();
    GridLayout gridLayout4 = new GridLayout();
    JLabel newPwdLabel1 = new JLabel();
    JLabel newPwdLabel2 = new JLabel();
    JButton changePwdButton = new JButton();
    String blankLine = "                                                                  ";
    String blankMessage = blankLine + blankLine + blankLine + blankLine + blankLine + blankLine + blankLine;

    /**
    Construct the component as a JavaBean
    */
    public GulchLoginPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchLoginPane(GulchLogin parent) {
        parentPanel = parent;
        tabbedPane = (GulchTabbedPane) parentPanel.parent;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    private void jbInit() {
        //this.setPreferredSize(new Dimension(300, 345));
        loginButton.setText("Log IN");
        loginButton.setPreferredSize(new Dimension(50, 29));
        loginButton.setFont(new Font("Dialog", 1, 14));
        loginButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    loginButton_actionPerformed(e);
                }
                catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
        logoutButton.setText("Log OUT");
        logoutButton.setPreferredSize(new Dimension(50, 29));
        logoutButton.setFont(new Font("Dialog", 1, 14));
        logoutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                logoutButton_actionPerformed(e);
            }
        });
        usernameTextField.setMaximumSize(new Dimension(70, 24));
        usernameTextField.setFont(new Font("Dialog", 1, 16));
        this.setNextFocusableComponent(usernameTextField);
        this.setAlignmentX((float) 0.1);
        this.setAlignmentY((float) 0.1);
        this.setMinimumSize(new Dimension(250, 300));
        parentPanel.setLayout(gridLayout1);
        usernameTextField.setNextFocusableComponent(passwordTextField);
        passwordTextField.setNextFocusableComponent(loginButton);
        usernameLabel.setText("User name:");
        usernameLabel.setFont(new Font("Dialog", 1, 16));
        passwordLabel.setText("Password:");
        passwordLabel.setMaximumSize(new Dimension(70, 20));
        passwordLabel.setPreferredSize(new Dimension(70, 20));
        passwordLabel.setFont(new Font("Dialog", 1, 16));
        passwordLabel.setMinimumSize(new Dimension(70, 20));
        messageTextArea.setLineWrap(true);
        messageTextArea.setMinimumSize(new Dimension(100, 40));
        messageTextArea.setRows(4);
        messageTextArea.setText("message: Please enter your user name and password and then press the Login button.");
        messageTextArea.setPreferredSize(new Dimension(290, 75));
        messageTextArea.setFont(new Font("Dialog", 1, 16));
        messageTextArea.setEditable(false);
        jPanel1.setPreferredSize(new Dimension(280, 48));
        gridLayout2.setRows(2);
        gridLayout2.setHgap(5);
        gridLayout2.setColumns(2);
        gridLayout2.setVgap(5);
        jPanel2.setPreferredSize(new Dimension(200, 29));
        gridLayout3.setVgap(5);
        gridLayout3.setHgap(5);
        verticalFlowLayout1.setVgap(11);
        verticalFlowLayout1.setHorizontalFill(false);
        spacesComboBox.setPreferredSize(new Dimension(210, 24));
        jPanel3.setLayout(gridLayout4);
        gridLayout4.setHgap(5);
        gridLayout4.setRows(2);
        gridLayout4.setColumns(2);
        gridLayout4.setVgap(5);
        newPwdLabel1.setText("New password:");
        newPwdLabel1.setFont(new Font("Dialog", 2, 12));
        newPwdLabel2.setText("New password:");
        newPwdLabel2.setFont(new Font("Dialog", 2, 12));
        changePwdButton.setText("Change Password");
        changePwdButton.setFont(new Font("Dialog", 2, 12));
        changePwdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                changePwdButton_actionPerformed(e);
            }
        });
        jPanel1.setLayout(gridLayout2);
        jPanel2.setLayout(gridLayout3);
        setLayout(verticalFlowLayout1);
        this.add(spacesComboBox, null);
        jPanel1.add(usernameLabel, null);
        jPanel1.add(usernameTextField, null);
        jPanel1.add(passwordLabel, null);
        jPanel1.add(passwordTextField, null);
        this.add(jPanel1, null);
        this.add(jPanel2, null);
        jPanel2.add(loginButton, null);
        jPanel2.add(logoutButton, null);
        jPanel3.add(newPwdLabel2, null);
        jPanel3.add(jPasswordField1, null);
        jPanel3.add(newPwdLabel1, null);
        jPanel3.add(jPasswordField2, null);
        this.add(jPanel3, null);
        this.add(changePwdButton, null);
        this.add(messageTextArea, null);
    }

    /**
    Fill refreshSpacesComboBox with list of information spaces
    */
    void refreshSpacesComboBox() {
        Vector items = tabbedPane.state1.getListOfSpaces();
        if (spacesComboBox.getItemCount() > 0) {spacesComboBox.removeAllItems();}
        for (int i = 0; i < items.size(); i++) {
            String row = (String) items.elementAt(i);
            spacesComboBox.addItem(row);
            if (row.equalsIgnoreCase("Artifact")) {
                spacesComboBox.setSelectedItem(row);
            }
        }
        return;
    }

    void loginButton_actionPerformed(ActionEvent e) {
        if (tabbedPane.state1.getCurrentAuthorNid() != 0) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("message: You must log OUT first.");
            return;
        }
        setUsername(usernameTextField.getText());
        setPassword(new String(passwordTextField.getPassword()));
        if (getUsername().length() == 0) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("message: You must enter a user name.");
            return;
        }
        if (getPassword().length() == 0) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("message: You must enter a password.");
            return;
        }

        //set hourglass cursor
        tabbedPane.setHourglassCursor();

        //check if new database space is selected
        int oldDBsid = DBsid;
        String newDB = (String) spacesComboBox.getSelectedItem();
        //DBsid = tabbedPane.interfaceMgr1.checkDBname(newDB);
        //if (DBsid > 0) {tabbedPane.interfaceMgr1.logChange("LOG_CHANGE_DB", 0, oldDBsid, DBsid); }

        //check database for validity, return nid of Author or 0
//System.out.println("enter tabbedPane.interfaceMgr1.validateLogin");
        int nid = tabbedPane.interfaceMgr1.validateLogin(getUsername(), getPassword(), newDB);
//System.out.println("exit tabbedPane.interfaceMgr1.validateLogin");
        //process invalid login
        if (nid == 0) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("message: User name or password is not valid in this system. Please try again.");
            return;
        }
        //process valid login
        messageTextArea.setText(blankMessage);
        messageTextArea.setText("message:  Press the LogOUT button when you are finished.");
        tabbedPane.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_PERSONAL);
        tabbedPane.authorize(nid);
        //reset default cursor
        tabbedPane.setDefaultCursor();
    }

    void logoutButton_actionPerformed(ActionEvent e) {
        setUsername("");
        usernameTextField.setText(getUsername());
        setPassword("");
        passwordTextField.setText(getPassword());
        messageTextArea.setText(blankMessage);
        messageTextArea.setText("message: Please enter your user name and password and then press the Login button.");
        tabbedPane.state1.setCurrentAuthorNid(0);
        tabbedPane.unauthorize(0);
    }

    void changePwdButton_actionPerformed(ActionEvent e) {
        if (tabbedPane.state1.getCurrentAuthorNid() == 0) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("message: You must log in with your old password first before changing passwords.");
        }
        else {
            String pw1 = new String(jPasswordField1.getPassword());
            String pw2 = new String(jPasswordField2.getPassword());
            if (pw1.length() == 0) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("message: You must enter a new password.");
            }
            else {
                if (pw1.equalsIgnoreCase(pw2)) {
                    tabbedPane.interfaceMgr1.setNewPassword(tabbedPane.getAuthor(), pw1);
                    messageTextArea.setText(blankMessage);
                    messageTextArea.setText("message: New password set.");
                }
                else {
                    messageTextArea.setText(blankMessage);
                    messageTextArea.setText("message: You must enter the same new password in each field.");
                }
            }
        }
    }

    public void setUsername(String newUsername) {
        username = newUsername;
    }

    public String getUsername() {
        return username;
    }

    public void setPassword(String newPassword) {
        password = newPassword;
    }

    public String getPassword() {
        return password;
    }

}
