//File:       InterfaceNetClient.java
//Title:      Net Connection
//Version:
//Copyright:  Copyright (c) 1998
//Author:     R.
//Company:    L3D
//Description: Client Side
//
package pow2000;

import java.net.*;
import java.io.*;
import java.lang.*;

public class InterfaceNetClient {
  private Socket clientSocket;

  public InterfaceNetClient(String host, int port) {
        try {
            clientSocket = new Socket(host, port);
System.out.println("Welcome to WebGuide2000 !");
//System.out.println("WebGuide connected to "+host+" on port # "+port);
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
  }

  /**
     Return 0 if it gets an error, or <> 0 otherwise
  */
  public void write(InterfaceDataSerialized msg) throws IOException {
//System.out.println("InterfaceNetClient sending: "+msg.getCommand());
         ObjectOutputStream outMsg = new ObjectOutputStream (clientSocket.getOutputStream());
         outMsg.writeObject(msg);
         outMsg.flush();
  }

  /**
     Return the string read or null otherwise
  */
  public InterfaceDataSerialized read() throws IOException {
        InterfaceDataSerialized inMsg = new InterfaceDataSerialized();
        ObjectInputStream object = new ObjectInputStream(clientSocket.getInputStream());
        try {
            inMsg = (InterfaceDataSerialized) object.readObject();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
//System.out.println("InterfaceNetClient receiving: "+inMsg.getCommand());
        return inMsg;
  }

  public void stopClient() throws IOException {
            clientSocket.close();
  }

  /**
     Initializes the clientSocket Socket variable
  */
  public boolean checkConnection () {
         if (clientSocket == null) return false;
         else return true;
  }

}
