//File:       PowServer.java
//Title:      Server for POW! Perspectives On the Web
//Version:
//Copyright:  Copyright (c) 1999
//Author:     R.
//Company:    L3D
//Description:  

package pow2000;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
* PowServer creates the InterfaceNetServer, which established the connection to the database class.
*/
public class PowServer {
  static int port;
  static String server;
  private static InterfaceNetServer Server;

  /**
  * This is the main method in the server
  * It creates:
  *             dbObj (Object)  : db Class
  *             Server (Object) : InterfaceNetServer Class
  * It lives, while the server is running.
  */
 public static void main(String[] args) {
    try  {
         if (args.length < 2) {
             server = InterfaceMessageDef.computerServer;
             port = InterfaceMessageDef.DBportValue;
         } else {
             server = args[0].toString();
             port = Integer.parseInt(args[1].toString());
         }
         System.out.println("Welcome to WebGuide2000 -- 10/08/00 release");
         //System.out.println("WebGuide Server is running on " + server + " at Port #" + port);
         Server = new InterfaceNetServer(port);
         System.out.println("WebGuide Server was shut down.");
    }
    catch (Exception e) {
         System.out.println(e.getMessage());
         e.printStackTrace();
    }
  }

}
