
//Title:        GulchPerspectivesPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Component for GulchEPerspectives

package gulch2000;

import javax.swing.*;
import javax.swing.tree.*;

import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.borland.jbcl.layout.VerticalFlowLayout;

public class GulchPerspectivesPane extends JPanel {
    public GulchPerspectives parentPanel = null;
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
    JLabel newLabel = new JLabel();
    JTextField newTextField = new JTextField();
    JLabel firstLabel = new JLabel();
    JTextField firstTextField = new JTextField();
    JLabel secondLabel = new JLabel();
    JTextField secondTextField = new JTextField();
    JButton firstButton = new JButton();
    JButton secondButton = new JButton();
    JLabel jLabel1 = new JLabel();
    JButton changeButton = new JButton();
    JButton homeButton = new JButton();
    JButton promoteButton = new JButton();
    JButton newAfterButton = new JButton();
    JButton newBelowButton = new JButton();
    JButton newNameButton = new JButton();
    JButton deleteButton = new JButton();
    JButton after2ndButton = new JButton();
    JButton below2ndButton = new JButton();
    JTextArea msgTextArea = new JTextArea();

    /**
    Construct the component as a JavaBean
    */
    public GulchPerspectivesPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchPerspectivesPane(GulchPerspectives pane) {
        parentPanel = pane;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        //this.setPreferredSize(new Dimension(300, 500));
        this.setFont(new Font("Dialog", 1, 14));
        this.setMinimumSize(new Dimension(250, 300));
        newLabel.setText("type name of new perspective:");
        newLabel.setPreferredSize(new Dimension(200, 10));
        firstLabel.setText("1st selected perspective:");
        firstLabel.setPreferredSize(new Dimension(290, 10));
        firstTextField.setText(" ");
        firstTextField.setEditable(false);
        secondLabel.setText("2nd selected perspective:");
        secondLabel.setPreferredSize(new Dimension(290, 10));
        secondTextField.setText(" ");
        secondTextField.setEditable(false);
        firstButton.setText("use selected item as 1st perspective");
        firstButton.setPreferredSize(new Dimension(290, 20));
        firstButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                firstButton_actionPerformed(e);
            }
        });
        secondButton.setText("use selcted item as 2nd perspective");
        secondButton.setPreferredSize(new Dimension(290, 20));
        secondButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                secondButton_actionPerformed(e);
            }
        });
        jLabel1.setPreferredSize(new Dimension(200, 10));
        changeButton.setText("change to 1st selected perspective");
        changeButton.setPreferredSize(new Dimension(290, 20));
        changeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                changeButton_actionPerformed(e);
            }
        });
        homeButton.setText("change to home personal perspective");
        homeButton.setPreferredSize(new Dimension(290, 20));
        homeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                homeButton_actionPerformed(e);
            }
        });
        newAfterButton.setText("add new perspective after 1st selection");
        newAfterButton.setPreferredSize(new Dimension(290, 20));
        newAfterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newAfterButton_actionPerformed(e);
            }
        });
        newBelowButton.setText("add new perspective below 1st selection");
        newBelowButton.setPreferredSize(new Dimension(290, 20));
        newBelowButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newBelowButton_actionPerformed(e);
            }
        });
        newNameButton.setText("change 1st selection to new perspective name");
        newNameButton.setPreferredSize(new Dimension(290, 20));
        newNameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newNameButton_actionPerformed(e);
            }
        });
        deleteButton.setText("delete 1st selection");
        deleteButton.setPreferredSize(new Dimension(290, 20));
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                deleteButton_actionPerformed(e);
            }
        });
        after2ndButton.setText("add 1st selection after 2nd (inherit)");
        after2ndButton.setPreferredSize(new Dimension(200, 20));
        after2ndButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                after2ndButton_actionPerformed(e);
            }
        });
        below2ndButton.setText("add 1st selection below 2nd (inherit)");
        below2ndButton.setPreferredSize(new Dimension(290, 20));
        below2ndButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                below2ndButton_actionPerformed(e);
            }
        });
        msgTextArea.setText("messages:");
        msgTextArea.setPreferredSize(new Dimension(70, 75));
        promoteButton.setText("use 1st selected perspective for promotion");
        promoteButton.setPreferredSize(new Dimension(290, 20));
        promoteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                promoteButton_actionPerformed(e);
            }
        });
        //disable buttons
        firstButton.setEnabled(false);
        secondButton.setEnabled(false);
        changeButton.setEnabled(false);
        homeButton.setEnabled(false);
        promoteButton.setEnabled(false);
        newAfterButton.setEnabled(false);
        newBelowButton.setEnabled(false);
        newNameButton.setEnabled(false);
        deleteButton.setEnabled(false);
        after2ndButton.setEnabled(false);
        below2ndButton.setEnabled(false);

        this.setLayout(verticalFlowLayout1);
        this.add(newLabel, null);
        this.add(newTextField, null);
        this.add(firstButton, null);
        this.add(firstLabel, null);
        this.add(firstTextField, null);
        this.add(secondButton, null);
        this.add(secondLabel, null);
        this.add(secondTextField, null);
        this.add(jLabel1, null);
        this.add(changeButton, null);
        this.add(homeButton, null);
        this.add(promoteButton, null);
        this.add(newAfterButton, null);
        this.add(newBelowButton, null);
        this.add(newNameButton, null);
        this.add(deleteButton, null);
        this.add(after2ndButton, null);
        this.add(below2ndButton, null);
        this.add(msgTextArea, null);
    }

    void secondButton_actionPerformed(ActionEvent e) {

    }

    void firstButton_actionPerformed(ActionEvent e) {

    }

    void changeButton_actionPerformed(ActionEvent e) {

    }

    void homeButton_actionPerformed(ActionEvent e) {

    }

    void promoteButton_actionPerformed(ActionEvent e) {

    }

    void newAfterButton_actionPerformed(ActionEvent e) {

    }

    void newBelowButton_actionPerformed(ActionEvent e) {

    }

    void newNameButton_actionPerformed(ActionEvent e) {

    }

    void deleteButton_actionPerformed(ActionEvent e) {

    }

    void after2ndButton_actionPerformed(ActionEvent e) {

    }

    void below2ndButton_actionPerformed(ActionEvent e) {

    }
}












