
//Title:        GulchWelcomePane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Welcome Pane for GulchLogin component

package gulch2000;

import java.awt.*;
import java.util.*;
import java.net.*;
import javax.swing.*;
import com.borland.jbcl.layout.VerticalFlowLayout;
import java.awt.event.*;
import pow2000.InterfaceMessageDef;

public class GulchWelcomePane extends JPanel {
    public GulchLogin parentPanel;
    JPanel middlePanel = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
    JLabel welcomeLabel = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JLabel jLabel1 = new JLabel();
    javax.swing.JButton manualButton = new javax.swing.JButton();

    /**
    Construct the component as a JavaBean
    */
    public GulchWelcomePane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchWelcomePane(GulchLogin parent) {
        parentPanel = parent;
        jbInit();
    }

    /**
    initialize the JavaBean
    */
    private void jbInit() {
        //this.setPreferredSize(new Dimension(575, 330));
        this.setLayout(borderLayout1);
        middlePanel.setLayout(verticalFlowLayout1);
        welcomeLabel.setText("Welcome to WebGuide 2000!");
        welcomeLabel.setHorizontalAlignment(0);
        welcomeLabel.setPreferredSize(new Dimension(250, 30));
        welcomeLabel.setForeground(new Color(170, 0, 255));
        welcomeLabel.setFont(new Font("Helvetica", 3, 20));
        welcomeLabel.setMinimumSize(new Dimension(30, 25));
        welcomeLabel.setPreferredSize(new Dimension(50, 40));
        jLabel6.setText("Enter a user name and password that is valid for this system");
        jLabel6.setHorizontalAlignment(0);
        jLabel6.setFont(new Font("Dialog", 1, 12));
        jLabel7.setText("or login as \"guest\" with password \"guest\".");
        jLabel7.setHorizontalAlignment(0);
        jLabel7.setFont(new Font("Dialog", 1, 12));
        jLabel8.setFont(new Font("Dialog", 1, 12));
        Date now = new Date();
//System.out.println("This build: " + now.toString().substring(0, 11));
System.out.println("version: WebGuide2000; 10/08/00 release");
        jLabel1.setText("10/08/00 release");     //change version release date here
        //jLabel1.setText("This build: " + now.toString().substring(0, 11));     
        jLabel1.setHorizontalAlignment(0);
        manualButton.setText("click here to display WebGuide User Manual in frame below");
        manualButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                manualButton_actionPerformed(e);
            }
        });
        jLabel8.setText("Login to WebGuide");
        jLabel8.setHorizontalAlignment(0);
        this.add(middlePanel, BorderLayout.SOUTH);
        middlePanel.add(jLabel8, null);
        middlePanel.add(jLabel6, null);
        middlePanel.add(jLabel7, null);
        middlePanel.add(manualButton, null);
        middlePanel.add(jLabel1, null);
        this.add(welcomeLabel, BorderLayout.CENTER);
    }

    /**
    Display WebGuide User Manual in HTML frame
    */
    void manualButton_actionPerformed(ActionEvent e) {
        try {
            URL cgiScript = new URL("http://www.cs.colorado.edu/~gerry/webguide/manual/");
            if (parentPanel.parent.isApplet()) {
                parentPanel.parent.getTheApp().getAppletContext().showDocument(cgiScript, "target");
            }
            //log that current author read the WebGuide User Manual
            parentPanel.parent.interfaceMgr1.logChange(InterfaceMessageDef.LOG_READ_MANUAL, parentPanel.parent.getCurrentPerspective(), 0, 0);
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

}
