//File: InterfaceDataSerialized.java
//Title:      Net Connection
//Version:
//Copyright:  Copyright (c) 1998
//Author:     R.
//Company:    L3D
//Description: Class that will be sent back-and-forth through the net
//
package pow2000;

import java.io.*;
import java.util.Vector;

/**
* Defines the class that will trafic data through the NET
*/
public class InterfaceDataSerialized implements Serializable {
    private int command;
	private int returnedStatus;               // pass author in here
    private Vector object;
    private int index = 0;
    // private int passAuthor = 0;                     // pass author

	/**
	* Constructor
    */
	public InterfaceDataSerialized () {
        object = new Vector();
        returnedStatus = 0;
        command = 0;
	}
/**
	public void setPassAuthor (int newAuthor) {
		passAuthor = newAuthor;
	}

	public int getPassAuthor () {
		return passAuthor;
	}
**/
	public void setCommand (int cmd) {
		command = cmd;
	}

	public int getCommand () {
		return command;
	}

	public void setStatus (int status) {
		returnedStatus = status;
	}

	public int getStatus () {
		return returnedStatus;
	}

	public void setObject (String str) {
		object.addElement((Object) str);
	}

	public void setObject (Object obj) {
		object.addElement(obj);
	}

	public void setObject (Vector obj) {
		object = obj;
	}

	public void setObject (InterfaceState obj) {
		object.addElement(obj);
	}

    public Object firstElement() {
        index = 1;
        return object.firstElement();
	}

    public Object nextElement() {
        if (index < object.size()){
            return object.elementAt(index++);
        }
        else {
            return null;
		} // index
  }

    public Object getObject() {
		return (Object) object.elementAt(index);
	}

    public Vector getVector() {
		return object;
	}

    public void clearObjects() {
        object.removeAllElements();
        index = 0;
    }

    public void setIndex (int i) {
        index = i;
    }

}  
